local function mirror_init()
	checked = false;
	
	mod_firstSeenBeat = GAMESTATE:GetSongBeat()
end

--how can I make simple m0d?
--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
--it's a simple mod

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end

--lua course :D
curmod = 1;
--{beat,mod,player}
mods = {
{25, '*0.25 100 distant'},
-- {119, '*1 150% hallway'},
{119, '*1 25% flip'},
{119, '*1 -75% invert'},
{145, '*2 0% flip'},
{145, '*2 0% invert'},

-- Bombas Inicio
{148, '*10 200 beat'},
{148.25, '*10 0 beat'},

{153, '*10 200 beat'},
{153.25, '*10 0 beat'},

{156, '*10 200 beat'},
{156.25, '*10 0 beat'},

{162, '*10 200 beat'},
{162.5, '*10 0 beat'},

{165, '*10 200 beat'},
{165.5, '*10 0 beat'},

{168, '*10 200 beat'},
{168.5, '*10 0 beat'},

{170, '*10 200 beat'},
{170.5, '*10 0 beat'},

{177, '*10 200 beat'},
{177.5, '*10 0 beat'},
--Bombas Fin
--Normal
{241, '*10 0 distant'},

{261, '*10 200 beat'},
{262, '*10 0 beat'},

--Distant
{315, '*0.25 100 distant'},

-- Giro
{376, '*1 25% flip'},
{376, '*1 -75% invert'},

{400, '*2 0% flip'},
{400, '*2 0% invert'},

{411, '*0.5 150 distant'},
{425, '*0.25 100 distant'},

{485, '*10 200 beat'},
{485.25, '*10 0 beat'},

{487, '*10 200 beat'},
{487.25, '*10 0 beat'},

{491, '*10 200 beat'},
{491.25, '*10 0 beat'},

-- {90,'*2 0 mini'}, --clearall
-- {90,'*2 -70 mini'},
-- {103,'*2 -50 mini'},
-- {124,'*2 -70 mini'},
-- {136,'*2 0 mini'}, --clearall
-- {160,'*2 0 mini'}, --clearall
-- {199,'*1 -75 mini'},
-- {225,'*2 -100 mini'},
-- {232,'*2 0 mini'}, --clearall
-- {232,'*2 -100 beat'},
-- {264,'*2 -150 beat'},
-- {295,'*2 0 beat'}, --clearall
-- {298,'*2 -100 beat'},
-- {330,'*2 -150 beat'},
-- {351,'*2 0 beat'}, --clearall
-- {354,'*0.125 100 dark'},
-- {355,'*0.5 -450 mini'},
--{358,'*2 -600 mini'},
}

local fluct = 1

local function mirror_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end

local function mirror_mod(str)
	for i=1,2 do
		mirror_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

local function mirror_update(self, delta)
	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		mirror_mod(total_mod_str)
	end
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		if table.getn(mods[curmod]) < 3 then
			add_mod(mods[curmod][2])
		else
			mirror_mod_internal(mods[curmod][2], 'PlayerNumber_P' .. mods[curmod][3])
		end
		curmod = curmod+1
	end

	execute_mods()
end


return Def.ActorFrame{
	OnCommand= function(self)
		mirror_init()
		self:SetUpdateFunction(mirror_update)
							
		end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
}